#!/bin/bash
# Ecrit par olaf.10
# Version 0.1
if [ ! -f /usr/bin/notify-send ]; then
	zenity --notification --text="Le programme « notify-send » n'est pas installé.
Vous pouvez l'installer en saisissant :
sudo apt-get install libnotify-bin" &
fi
echo "Les fichiers suivants seront inclus dans la nouvelle image disque :" > /tmp/livedvd-multiboot
rm -rf /home/${USER}/liveDVD
mkdir -p /home/${USER}/liveDVD/boot/grub
if [ -f /usr/share/grub/ascii.pff ]
	then
		cp /usr/share/grub/ascii.pff /home/${USER}/liveDVD/boot/grub/ascii.pff
		cp /usr/share/grub/unicode.pff /home/${USER}/liveDVD/boot/grub/unicode.pff
		echo 'insmod videotest
insmod tga
insmod png
insmod gfxterm
insmod lspci
insmod vbeinfo
insmod vbe
insmod ntfs
insmod chain
insmod biosdisk
insmod font

font /boot/grub/ascii.pff
set gfxmode=640x480
terminal gfxterm
#background_image /boot/grub/fichier.tga

set default=0
set timeout=30
set fallback=1
set root=(hd96)
set menu_color_normal=cyan/blue
set menu_color_highlight=white/blue' > /home/${USER}/liveDVD/boot/grub/grub.cfg
	elif [ -f /usr/share/grub/ascii.pf2 ]
		then
			cp /usr/share/grub/ascii.pf2 /home/${USER}/liveDVD/boot/grub/ascii.pf2
			cp /usr/share/grub/unicode.pf2 /home/${USER}/liveDVD/boot/grub/unicode.pf2
			echo 'insmod videotest
insmod tga
insmod png
insmod gfxterm
insmod lspci
insmod vbeinfo
insmod vbe
insmod ntfs
insmod chain
insmod biosdisk
insmod font

loadfont /boot/grub/ascii.pf2
set gfxmode=640x480
terminal_output gfxterm
#background_image /boot/grub/fichier.tga

set default=0
set timeout=30
set fallback=1
set root=(hd96)
set menu_color_normal=cyan/blue
set menu_color_highlight=white/blue' >> /home/${USER}/liveDVD/boot/grub/grub.cfg
		else
			rm -rf /home/${USER}/liveDVD
			zenity --error --text="Le paquet logiciel « grub2 » n'est pas installé.
Vous pouvez l'installer en saisissant :
sudo apt-get install grub2"
			exit
fi

while [ 1 ]; do
FULL_PATH=
CHECK=
ISO=
FULL_PATH=`zenity --title='Veuillez choisir une image disque (fichier ISO)' --file-selection`
if [ "$?" = "1" ]; then
	rm -rf /home/${USER}/liveDVD
	exit
fi
ISO=`echo "$FULL_PATH" | sed 's#.*/##'`
if [ -f /home/${USER}/liveDVD/$ISO ]
	then
		notify-send "Ce fichier ($ISO) est déjà sélectionné"
	else
		CHECK=`echo "$FULL_PATH" | sed -e 's/.*\.iso/y/' -e 's/.*\.iSo/y/' -e 's/.*\.isO/y/' -e 's/.*\.iSO/y/' -e 's/.*\.Iso/y/' -e 's/.*\.ISo/y/' -e 's/.*\.IsO/y/' -e 's/.*\.ISO/y/'`
		if [ ! "$CHECK" = "y" ]
			then
				notify-send "Le fichier $ISO n'est pas un fichier ISO"
			else
				( echo "#Copie de $ISO vers « liveDVD »"
				cp -f "$FULL_PATH" /home/${USER}/liveDVD
				) | zenity --title="Opérations sur les fichiers" --progress --width=300 --auto-close --pulsate
				echo "- $ISO" >> /tmp/livedvd-multiboot
				echo "
menuentry \"Charger l'image disque $ISO\" {
search --set -f /$ISO
loopback loop /$ISO
linux (loop)/casper/vmlinuz locale=fr_FR bootkbd=fr console-setup/layoutcode=fr console-setup/variantcode=oss iso-scan/filename=/$ISO boot=casper file=/cdrom/preseed/ubuntu.seed noprompt quiet splash --
initrd (loop)/casper/initrd.lz
}" >> /home/${USER}/liveDVD/boot/grub/grub.cfg
				zenity --question --title="Faites votre choix" --text="Voulez-vous choisir une autre image disque ?"
				case "$?" in
					"0" ) another= ;;
					"1" ) break ;;
				esac
		fi
fi
done

# Ces 3 lignes proviennent d'un script de AnsuzPeorth :
taille=`du -bs /home/${USER}/liveDVD | cut -d/ -f1`
total=$((total+taille))
resultat=$(echo "`echo "(${total}/1024/1024)" | bc` Mio" | sed -e '/ \./ s// 0./g' -e '/^\./ s//0./')

echo "
La taille du nouveau fichier ISO sera de $resultat
NB : Un DVD5 peut contenir 4482 Mio (4700 Mo)" >> /tmp/livedvd-multiboot

cat /tmp/livedvd-multiboot | zenity --title="Récapitulatif" --text-info --width=500 --height=320 &

ZENITY=$(zenity --list --radiolist --width=300 --height=190 --title="Faites votre choix" --text="Voulez-vous créer cette image disque ?" \
--column="Sélect." --column="" TRUE "Oui" FALSE "Non - Quitter" FALSE "Modifier le fichier grub.cfg" );
if [ "$?" = "1" ]; then
	rm -rf /home/${USER}/liveDVD
	exit
fi
case "$ZENITY" in
	"Oui" )
		( echo "#Création de « ubuntu-livedvd-multiboot.iso »"
		grub-mkrescue --output="/home/${USER}/ubuntu-livedvd-multiboot.iso" /home/${USER}/liveDVD
		grub-mkrescue --overlay="/home/${USER}/liveDVD" --output="/home/${USER}/ubuntu-livedvd-multiboot.iso"
		) | zenity --title="Opérations sur les fichiers" --progress --width=300 --auto-close --pulsate
		;;
	"Non - Quitter" )
		rm -rf /home/${USER}/liveDVD
		exit
		;;
	"Modifier le fichier grub.cfg" )
		if [ -f /usr/bin/gedit ]; then gedit /home/${USER}/liveDVD/boot/grub/grub.cfg &
		fi
		if [ -f /usr/bin/kate ]; then kate /home/${USER}/liveDVD/boot/grub/grub.cfg &
		fi
		if [ -f /usr/bin/kwrite ]; then kwrite /home/${USER}/liveDVD/boot/grub/grub.cfg &
		fi
		if [ -f /usr/bin/leafpad ]; then leafpad /home/${USER}/liveDVD/boot/grub/grub.cfg &
		fi
		if [ -f /usr/bin/mousepad ]; then mousepad /home/${USER}/liveDVD/boot/grub/grub.cfg &
		fi
		zenity --question --title="Faites votre choix" --text="Voulez-vous créer cette image disque
(une fois vos modifications effectuées) ?"
		case "$?" in
			"0" )
				( echo "#Création de « ubuntu-livedvd-multiboot.iso »"
				grub-mkrescue --output="/home/${USER}/ubuntu-livedvd-multiboot.iso" /home/${USER}/liveDVD
				grub-mkrescue --overlay="/home/${USER}/liveDVD" --output="/home/${USER}/ubuntu-livedvd-multiboot.iso"
				) | zenity --title="Opérations sur les fichiers" --progress --width=300 --auto-close --pulsate
				;;
			"1" )
				rm -rf /home/${USER}/liveDVD
				exit
				;;
		esac
		;;
esac
notify-send "Terminé" "Le fichier ISO devrait se trouver dans votre dossier personnel"
rm -rf /home/${USER}/liveDVD
exit

